Sketcher ConstrainSnellsLaw: Difference between revisions

From FreeCAD Documentation
(fixed script example)
No edit summary
 
(42 intermediate revisions by 12 users not shown)
Line 1: Line 1:
<languages/>
<languages/>
{{Page_in_progress}}
<translate>
<translate>

<!--T:13-->
{{Docnav
|[[Sketcher_ConstrainLock|Lock]]
|[[Sketcher_ToggleDrivingConstraint|Toggle driving/reference constraint]]
|[[Sketcher_Workbench|Sketcher]]
|IconL=Sketcher_ConstrainLock.svg
|IconR=Sketcher_ToggleDrivingConstraint.svg
|IconC=Workbench_Sketcher.svg
}}

<!--T:1-->
<!--T:1-->
{{GuiCommand
{{GuiCommand|Name=Constraint SnellsLaw|MenuLocation=Sketch → Sketcher Constraints → Constrain refraction (Snell's law)|Workbenches=[[Sketcher Workbench|Sketcher]], [[PartDesign Workbench|PartDesign]]}}
|Name=Sketcher ConstrainSnellsLaw
|MenuLocation=Sketch → Sketcher constraints → Constrain refraction (Snell's law)
|Workbenches=[[Sketcher_Workbench|Sketcher]]
|Shortcut={{KEY|K}} {{KEY|W}}
|Version=0.15
}}


==Description== <!--T:2-->
==Description== <!--T:17-->
Constrains two lines to follow the law of refraction of light as it penetrates through an interface, where two materials of different refraction indices meet. See [http://en.wikipedia.org/wiki/Snell%27s_law Snell's law] on Wikipedia for more info.
[[Image:Snells law2 witheq.svg|thumb|left|200px|Snell's law]]
{{clear}}


==How to use== <!--T:3-->
<!--T:2-->
The [[Image:Sketcher_ConstrainSnellsLaw.svg|24px]] [[Sketcher_ConstrainSnellsLaw|Sketcher ConstrainSnellsLaw]] tool constrains two lines to follow the law of refraction of light as it penetrates through an interface where two materials of different refraction indices meet. See [http://en.wikipedia.org/wiki/Snell%27s_law Snell's law] on Wikipedia for more info.
[[Image:Sketcher SnellsLaw Example1.png|thumb|none|500px|The sequence of clicks is indicated by yellow arrows with numbers. n1, n2 are labeles on this picture to show where the indices of refraction are.]]


</translate>
<!--T:4-->
[[Image:Snells_law2_witheq.svg|x400px]]
* You'll need two lines that are to follow a beam of light, and a curve to act as an interface. The lines should be on different sides of the interface.
<translate>
* Select the endpoint of one line, an endpoint of another line, and the interface edge. The interface can be a line, circle/arc, ellipse/arc of ellipse. Note the order you've selected the endpoints.
<!--T:20-->
* Invoke the constraint. A dialog will appear asking for a ratio of indices of refraction n2/n1. n2 corresponds to the medium where the second selected endpoint's line resides, n1 is for the first line.
{{Caption|Snell's Law}}
* The endpoints will be made coincident (if needed), constrained onto the interface (if needed), and the Snell's law will become constrained.


<!--T:5-->
==Usage== <!--T:18-->
Note that there are several [[Sketcher helper constraint|helper constraints]] smart-added (point-on-object, coincident), and they can be deleted if they cause redundancy, or added manually if they were not added automatically. For the actual Snell's law constraint, the endpoints of lines must coincide and lie on the interface, otherwise the behavior is undefined.


</translate>
<!--T:6-->
[[Image:Sketcher_SnellsLaw_Example1.png|500px]]
Using polyline tool, it is possible to speedup drawing of rays of light. In this case, one can select two coincident endpoints by box selection.
<translate>
<!--T:21-->
{{Caption|The sequence of clicks is indicated by yellow arrows with numbers, n1 and n2 show where the indices of refraction are}}

<!--T:4-->
# Prepare two lines to represent a beam of light, and an edge to act as an interface. The lines should be on different sides of the interface. The interface can be a [[Sketcher_CreateLine|line]], an [[Sketcher_CreateArc|arc]], a [[Sketcher_CreateCircle|circle]] or a [[Sketcher_CompCreateConic|conic]].
# Select an endpoint of the first line, an endpoint of the second line, and the interface edge. Note the selection order of the endpoints.
# There are several ways to invoke the tool:
#* Select the {{MenuCommand|Sketch → Sketcher constraints → [[Image:Sketcher_ConstrainSnellsLaw.svg|16px]] Constrain refraction (Snell's law)}} option from the menu.
#* Use the keyboard shortcut: {{KEY|K}} then {{KEY|W}}.
# The {{MenuCommand|Refractive index ratio}} dialog opens.
# Enter the {{MenuCommand|Ratio n2/n1}}. Where {{MenuCommand|n2}} is for the medium where the second selected line resides, and {{MenuCommand|n1}} is for the first line's medium.
# A Snell's law constraint is added. If required the endpoints are made [[Sketcher_ConstrainCoincident|coincident]] and constrained [[Sketcher_ConstrainPointOnObject|onto the interface]]. These additional constraints are called [[Sketcher_helper_constraint|helper constraints]].

==Notes==


==Remarks== <!--T:7-->
<!--T:7-->
* The actual Snell's law constraint enforces the plain law equation n1*sin(theta1) = n2*sin(theta2). It needs the line ends to be made coincident and on the interface by other constraints. The necessary helper constraints are added automatically based on the current coordinates of the elements.
* The actual Snell's law constraint enforces the plain law equation n1*sin(theta1) = n2*sin(theta2). It needs the line ends to be made coincident and on the interface by other constraints, otherwise the behavior is undefined. The necessary helper constraints are added automatically based on the current coordinates of the elements.
* Python routine does not add the helper constraints. These must be added manually by the script (see example in Scripting section).
* In Python the helper constraints must be added manually (see [[#Scripting|Scripting]]).
* These helper constraints can be temporarily deleted and the endpoints dragged apart, which can be useful in case one wants to construct a reflected ray or birefringence rays.
* These helper constraints can be temporarily deleted and the endpoints dragged apart, which can be useful in case one wants to construct a reflected ray or birefringence rays.
* Unlike the reality, refraction indices are associated with rays of light, but not according to the sides of the boundary. This is useful to emulate birefringence, construct paths of different wavelengths due to refraction, and easily construct angle of onset of total internal reflection.
* Unlike the reality, refraction indices are associated with rays of light, but not according to the sides of the boundary. This is useful to emulate birefringence, construct paths of different wavelengths due to refraction, and easily construct angle of onset of total internal reflection.
* Both rays can be on the same side of the interface, satisfying the constraint equation. This is physical nonsense, unless the ratio n2/n1 is 1.0, in which case the constraint emulates a reflection.
* Both rays can be on the same side of the interface, satisfying the constraint equation. This is physical nonsense, unless the ratio n2/n1 is 1.0, in which case the constraint emulates a reflection.
* Arcs of circle and ellipse are also accepted as rays (physical nonsense).
* Arcs of circle and ellipse are also accepted as rays. But this is also physical nonsense.

==Scripting== <!--T:23-->

<!--T:8-->
The constraints can be created from [[Macros|macros]] and from the [[Python|Python]] console by using the following function:


==Scripting== <!--T:8-->
The constraints can be created from [[macros]] and from the python console by using the following function:
</translate>
</translate>
{{Code|code=
{{Code|code=
Line 39: Line 71:
}}
}}
<translate>
<translate>

<!--T:9-->
<!--T:9-->
where:
where:
:* <tt>Sketch</tt> is a sketch object
:* {{incode|Sketch}} is a sketch object
:* <tt>line1</tt> and <tt>pointpos1</tt> are two integers identifying the endpoint of the line in medium with refractive index of ''n1''. <tt>line1</tt> is the line's index in the sketch (the value, returned by Sketch.addGeometry), and <tt>pointpos1</tt> should be 1 for start point and 2 for end point.
:* {{incode|line1}} and {{incode|pointpos1}} are two integers identifying the endpoint of the line in medium with refractive index of ''n1''. {{incode|line1}} is the line's index in the sketch (the value, returned by Sketch.addGeometry), and {{incode|pointpos1}} should be 1 for start point and 2 for end point.
:* <tt>line2</tt> and <tt>pointpos2</tt> are the indexes specifying the endpoint of the second line (in medium ''n2'')
:* {{incode|line2}} and {{incode|pointpos2}} are the indexes specifying the endpoint of the second line (in medium ''n2'')
:* <tt>n2byn1</tt> is a floating-point number equal to the ratio of refractive indices ''n2''/''n1''
:* {{incode|interface}} is the index specifying the line indicating the position of the interface between medium ''n1'' and medium ''n2''
:* {{incode|n2byn1}} is a floating-point number equal to the ratio of refractive indices ''n2/n1''

<!--T:25-->
The [[Sketcher_scripting|Sketcher scripting]] page explains the values which can be used for {{incode|line1}}, {{incode|pointpos1}}, {{incode|line2}}, {{incode|pointpos2}} and {{incode|interface}} and contains further examples on how to create constraints from Python scripts.


<!--T:10-->
<!--T:10-->
Example:
Example:

</translate>
</translate>
{{Code|code=
{{Code|code=
Line 56: Line 94:
StartPoint = 1
StartPoint = 1
EndPoint = 2
EndPoint = 2
MiddlePoint = 3


f = App.activeDocument().addObject("Sketcher::SketchObject","Sketch")
f = App.activeDocument().addObject("Sketcher::SketchObject","Sketch")
Line 75: Line 112:
<translate>
<translate>



==Version== <!--T:11-->
<!--T:14-->
The constraint was introduced in FreeCAD v0.15.4387
{{Docnav
|[[Sketcher_ConstrainLock|Lock]]
|[[Sketcher_ToggleDrivingConstraint|Toggle driving/reference constraint]]
|[[Sketcher_Workbench|Sketcher]]
|IconL=Sketcher_ConstrainLock.svg
|IconR=Sketcher_ToggleDrivingConstraint.svg
|IconC=Workbench_Sketcher.svg
}}


</translate>
</translate>
{{Sketcher_Tools_navi{{#translation:}}}}
{{clear}}
{{Userdocnavi{{#translation:}}}}

Latest revision as of 21:15, 11 March 2024

This documentation is a work in progress. Please don't mark it as translatable since it will change in the next hours and days.

Sketcher ConstrainSnellsLaw

Menu location
Sketch → Sketcher constraints → Constrain refraction (Snell's law)
Workbenches
Sketcher
Default shortcut
K W
Introduced in version
0.15
See also
None

Description

The Sketcher ConstrainSnellsLaw tool constrains two lines to follow the law of refraction of light as it penetrates through an interface where two materials of different refraction indices meet. See Snell's law on Wikipedia for more info.

Snell's Law

Usage

The sequence of clicks is indicated by yellow arrows with numbers, n1 and n2 show where the indices of refraction are

  1. Prepare two lines to represent a beam of light, and an edge to act as an interface. The lines should be on different sides of the interface. The interface can be a line, an arc, a circle or a conic.
  2. Select an endpoint of the first line, an endpoint of the second line, and the interface edge. Note the selection order of the endpoints.
  3. There are several ways to invoke the tool:
    • Select the Sketch → Sketcher constraints → Constrain refraction (Snell's law) option from the menu.
    • Use the keyboard shortcut: K then W.
  4. The Refractive index ratio dialog opens.
  5. Enter the Ratio n2/n1. Where n2 is for the medium where the second selected line resides, and n1 is for the first line's medium.
  6. A Snell's law constraint is added. If required the endpoints are made coincident and constrained onto the interface. These additional constraints are called helper constraints.

Notes

  • The actual Snell's law constraint enforces the plain law equation n1*sin(theta1) = n2*sin(theta2). It needs the line ends to be made coincident and on the interface by other constraints, otherwise the behavior is undefined. The necessary helper constraints are added automatically based on the current coordinates of the elements.
  • In Python the helper constraints must be added manually (see Scripting).
  • These helper constraints can be temporarily deleted and the endpoints dragged apart, which can be useful in case one wants to construct a reflected ray or birefringence rays.
  • Unlike the reality, refraction indices are associated with rays of light, but not according to the sides of the boundary. This is useful to emulate birefringence, construct paths of different wavelengths due to refraction, and easily construct angle of onset of total internal reflection.
  • Both rays can be on the same side of the interface, satisfying the constraint equation. This is physical nonsense, unless the ratio n2/n1 is 1.0, in which case the constraint emulates a reflection.
  • Arcs of circle and ellipse are also accepted as rays. But this is also physical nonsense.

Scripting

The constraints can be created from macros and from the Python console by using the following function:

Sketch.addConstraint(Sketcher.Constraint('SnellsLaw',line1,pointpos1,line2,pointpos2,interface,n2byn1))

where:

  • Sketch is a sketch object
  • line1 and pointpos1 are two integers identifying the endpoint of the line in medium with refractive index of n1. line1 is the line's index in the sketch (the value, returned by Sketch.addGeometry), and pointpos1 should be 1 for start point and 2 for end point.
  • line2 and pointpos2 are the indexes specifying the endpoint of the second line (in medium n2)
  • interface is the index specifying the line indicating the position of the interface between medium n1 and medium n2
  • n2byn1 is a floating-point number equal to the ratio of refractive indices n2/n1

The Sketcher scripting page explains the values which can be used for line1, pointpos1, line2, pointpos2 and interface and contains further examples on how to create constraints from Python scripts.

Example:

import Sketcher
import Part
import FreeCAD

StartPoint = 1
EndPoint = 2

f = App.activeDocument().addObject("Sketcher::SketchObject","Sketch")

# add geometry to the sketch
icir = f.addGeometry(Part.Circle(App.Vector(-547.612366,227.479736,0),App.Vector(0,0,1),68.161979))
iline1 = f.addGeometry(Part.LineSegment(App.Vector(-667.331726,244.127090,0),App.Vector(-604.284241,269.275238,0)))
iline2 = f.addGeometry(Part.LineSegment(App.Vector(-604.284241,269.275238,0),App.Vector(-490.940491,256.878265,0)))
# add constraints
# helper constraints:
f.addConstraint(Sketcher.Constraint('Coincident',iline1,EndPoint,iline2,StartPoint)) 
f.addConstraint(Sketcher.Constraint('PointOnObject',iline1,EndPoint,icir)) 
# the Snell's law:
f.addConstraint(Sketcher.Constraint('SnellsLaw',iline1,EndPoint,iline2,StartPoint,icir,1.47))

App.ActiveDocument.recompute()